# Utilities

While it is possible to manage a Coventry server remotely with Apollo, there
are also a set of pbx command line utilities included with Coventry as well.
These can be accessed from a ssh login shell for a shell account that is a
member of the coventry group if one is used, or thru root. This can be used to
manage a purely dedicated stand-alone coventry server and associated phone
devices even without Apollo services installed.

These utilities may also be used in crontabs for scheduling automation, or in
other ways as part of a command admin interface with supporting shell scripts.
Many of these utilities integrate with a running coventry server thru it's IPC
facilities.

## pbx-message

Sends text messages to a locally running coventry server. The messages will
then be delivered to the correspending pbx phone extension or message group.
Sending to "all" is used to send a message to all registered devices. Text
messages could be injected from scripts or crontabs.

## pbx-passwd

Produce a password hash for a given user id. By default this uses shm to
determine what realm coventry runs under. There are options to specify a config
file or a realm, and a digest type, to use instead. pbx-passwd can also be used
to generate sip hashes for other generic devices and services. This utility
does not write or modify config files, but the hashes it generates can be
manually added to a coventry config.

## pbx-ping

Sends an option request to a sip endpoint at the specified uri and waits for a
response, while measuring response time. If an extension is used, the uri for
that extension as registered with coventry is pinged. This is useful because
you can ping sip devices by their registered coventry extension number rather
than having to know their ip address.

## pbx-presence

Gets or sets the extension presence state manually. Setting presence should
only happen for extensions that are both live and have no device published
override.

## pbx-realm

Show the sip authorization realm your coventry server is running under.  If
coventry is offline it shows an error.

## pbx-registry

This is often used for shell scripts that test Coventry registry properties,
like does user X exist. The exit code can then be used to branch shell scripts.
Optionally you can request the value of a given user's registry key item, or to
set the value of a feature key.  Finally, the \-c option can be used to clear
all persistent settings for the given user.

## pbx-runstate

Sets the running state of the coventry server. This activates a .state file
which has overrides to the current config. For example, it could be used to set
different ringing patterns at night.

Pbx-runstate can be used to set states even if coventry is not running. This
makes it possible to call it from cron jobs. If coventry is actively running
it issues a server reload request to apply the newly set state.

## pbx-status

Sends status request to a locally running coventry server. This utility can
both count active registrations and dump active sip endpoints registered with
coventry out to the display. It can also provide the Coventry service uptime.

